#include "encode.h"

/*
  ӥåȥޥ(bitMask)Υå
*/
void set_bitMask()
{
  int i;
  int bit = 0;

  for ( i = 0 ; i <= MAX_LENGTH ; i++ ) {
    bitMask[i] = bit;
    bit = ( bit << 1 ) | 1;
  }
}

/*
  ǡSSSS

  int data : ǡ

     : SSSS
*/
unsigned char calcSSSS( int data )
{
  int i;

  if ( data < 0 ) data *= -1;
  for ( i = SSSS_SIZE - 1 ; i > 0 ; i-- ) {
    int j = 1 << ( i - 1 );
    if ( ( data & j ) != 0 ) break;
  }

  return( i & 0x0F );
}

/*
  

  int* x  : xʬ
  int* y  : yʬ
  int* sx : xʬ
  int* sy : yʬ

    : >0 ... ˰ư : =0 ... ǤãƤ
*/
int zigzag_run( int* x, int* y, int* sx, int* sy )
{
  if ( *x == MCU_SIZE - 1 && *y == MCU_SIZE - 1 )
    return( 0 );

  *x += *sx;
  *y += *sy;
  if ( *x < 0 || *x >= MCU_SIZE || *y < 0 || *y >= MCU_SIZE ) {
    *sx *= -1;
    *sy *= -1;
    if ( *x < 0 ) {
      *x = 0;
      if ( *y >= MCU_SIZE ) {
	*x = 1;
	*y = MCU_SIZE - 1;
      }
    } else if ( *x >= MCU_SIZE ) {
      *x = MCU_SIZE - 1;
      *y += 2;
    } else if ( *y < 0 ) {
      *y = 0;
    } else {
      *x += 2;
      *y = MCU_SIZE - 1;
    }
  }

  return( 1 );
}

/*-----------------------------------------------------------------------------
  ŪHuffman̡Ÿ롼
-----------------------------------------------------------------------------*/

/*
  DCʬSSSSи٤򥫥Ȥ

  Mcu* mcu        : MCUǡ
  Mcu* mcu_end    : MCUǡ
  unsigned int* s : 
  unsigned int* e : 
*/
void dc_count( Mcu* mcu, Mcu* mcu_end, unsigned int* s, unsigned int* e )
{
  int prev_dc = 0;   /* DCʬ */
  unsigned int *ui;

  /* и٤ν */
  for ( ui = s ; ui < e ; ui++ )
    *ui = 0;

  for ( ; mcu < mcu_end ; mcu++ ) {
    int diff = ( mcu->d )[0][0] - prev_dc; /* DCʬȤκ */
    unsigned int ssss = calcSSSS( diff );
    if ( s + ssss < e )
      s[ssss]++;
    prev_dc = ( mcu->d )[0][0];
  }
}

/*
  ACʬRUN*SSSSи٤򥫥Ȥ

  Mcu* mcu        : MCUǡ
  Mcu* mcu_end    : MCUǡ
  unsigned int* s : 
  unsigned int* e : 
*/
void ac_count( Mcu* mcu, Mcu* mcu_end, unsigned int* s, unsigned int* e )
{
  unsigned int *ui;

  /* и٤ν */
  for ( ui = s ; ui < e ; ui++ )
    *ui = 0;

  for ( ; mcu < mcu_end ; mcu++ ) {
    int run = 0;
    int zrl_count = 0;
    int sx = -1, sy = 1;
    int x = 1, y = 0;
    do {
      int d = ( mcu->d )[x][y];
      if ( d == 0 ) {
	/* 0ʬλϡrun1 */
	if ( ++run >= RUN_SIZE ) {
	  /* runRUN_SIZEۤZRL */
	  ++zrl_count;
	  run -= RUN_SIZE;
	}
      } else {
	/* ZRL */
	int i;
	for ( i = 0 ; i < zrl_count ; i++ )
	  s[ZRL]++;
	unsigned int ssss = calcSSSS( d );
	if ( s + run * SSSS_SIZE + ssss < e )
	  s[run * SSSS_SIZE + ssss]++;
	run = zrl_count = 0;
      }
    } while ( zigzag_run( &x, &y, &sx, &sy ) != 0 );
    /* 0ʬϢ³ޤ޺Ǹã硢EOB */
    if ( run != 0 || zrl_count != 0 )
      s[EOB]++;
  }
}

/*
  ʥϥեޥڤٽ¤٤ʤ

  HuffmanTree* node : 
  HuffmanTree* s    : ϥեޥڤƬ
  HuffmanTree* next : ϥեޥڤΡǤ
  HuffmanTree* e    : ϥեޥڤ

              : !=NULL ... Υݥ : NULL ... Хåե­
*/
HuffmanTree* add_and_sort( HuffmanTree* node, HuffmanTree* s, HuffmanTree** next, HuffmanTree* e )
{
  HuffmanTree *p;

  if ( *next >= e ) {
    fprintf( stderr, "add_and_sort : Buffer over\n" );
    return( NULL );
  }
  for ( p = *next - 1 ; p->count > node->count && p >= s ; p-- )
    *( p + 1 ) = *p;
  *( p + 1 ) = *node;

  ( *next )++;
  return( p + 1 );
}

/*
  ϥեޥڤκ롼

  unsigned int* s          : 
  unsigned int* e          : 
  Huffman_Tree* tree_start : ϥեޥڤƬ
  Huffman_Tree* tree_end   : ϥեޥڤ

                     : !=NULL ... Υݥ : NULL ... Хåե­
*/
HuffmanTree* make_huffman_tree( unsigned int* s, unsigned int* e, HuffmanTree* tree_start, HuffmanTree* tree_end )
{
  int code;
  HuffmanTree node;
  HuffmanTree *root; /* ϥեޥڤκ */
  HuffmanTree *next; /* ɲäǤϥեޥڤκ */

  /* ٽ¤ؤĤ, */
  root = next = tree_start;
  for ( code = 0 ; s + code < e ; code++ ) {
    if ( s[code] > 0 ) {
      node.code = code;
      node.count = s[code];
      node.left = NULL;
      node.right = NULL;
      if ( ( root = add_and_sort( &node, tree_start, &next, tree_end ) ) == NULL )
	return( NULL );
    }
  }

  /* ǤҤȤĤʤä */
  if ( tree_start + 1 == next ) {
    next->left = tree_start;
    next->right = NULL;
    return( next );
  }

  /* ƬĤ򿷤«ͤ */
  while ( tree_start + 1 < next ) {
    node.count = tree_start->count + ( tree_start + 1 )->count;
    node.left = tree_start++;
    node.right = tree_start++;
    if ( ( root = add_and_sort( &node, tree_start, &next, tree_end ) ) == NULL )
      return( NULL );
  }

  return( root );
}

/*
  ϥեޥڤϥեޥ󥳡ɽؤѴ

  HuffmanTree* node   : ϥեޥڤ
  HuffmanCode* s      : ϥեޥơ֥Ƭ
  HuffmanCode* e      : ϥեޥơ֥
  unsigned int code   : ϥեޥ
  unsigned int length : ϥեޥĹ

                : >0 ...  : 0 ... Ĺӥåȿۤ
*/
int conv_huffman_tree_to_code( HuffmanTree* node, HuffmanCode* s, HuffmanCode* e, unsigned int code, unsigned int length )
{
  if ( node->right != NULL )
    if ( conv_huffman_tree_to_code( node->right, s, e, ( code << 1 ) + 1, length + 1  ) == 0 )
      return( 0 );
  if ( node->left != NULL )
    if ( conv_huffman_tree_to_code( node->left, s, e, code << 1, length + 1 ) == 0 )
      return( 0 );
  if ( node->right == NULL && node->left == NULL ) {
    if ( length > MAX_LENGTH ) {
      fprintf( stderr, "conv_huffman_tree_to_code : Huffamn length exceeds the limit\n" );
      return( 0 );
    }
    if ( s + node->code < e ) {
      ( s[node->code] ).code = code;
      ( s[node->code] ).length = length;
    }
  }

  return( 1 );
}

/*
  ϥեޥںᥤ롼

  Mcu* mcu                : MCUǡ
  Mcu* mcu_end            : MCUǡ
  HuffmanCode* s          : ϥեޥơ֥Ƭ
  HuffmanCode* e          : ϥեޥơ֥
  unsigned int* count     : 
  unsigned int* count_end : 
  void ( *pf )( Mcu*, Mcu*, unsigned int*, unsigned int* ) : ѴؿؤΥݥ
*/
int huffman_encode( Mcu* mcu, Mcu* mcu_end, HuffmanCode* s, HuffmanCode* e, unsigned int* count, unsigned int* count_end,
			   void ( *pf )( Mcu*, Mcu*, unsigned int*, unsigned int* ) )
{
  HuffmanTree* root;
  HuffmanCode* h;

  ( *pf )( mcu, mcu_end, count, count_end );
  if ( ( root = make_huffman_tree( count, count_end, huffmanTree, huffmanTree + HUFFMAN_MAX ) ) == NULL )
    return( 0 );
  for ( h = s ; h < e ; h++ )
    h->code = h->length = 0;
  if ( conv_huffman_tree_to_code( root, s, e, 0, 0 ) == 0 )
    return( 0 );

  return( 1 );
}

/*
  ϥեޥ󥳡ɤϥեޥڤѴ

  HuffmanCode* hc     : ϥեޥơ֥
  HuffmanTree* ht     : ϥեޥ
  HuffmanTree* ht_end : ϥեޥڤμΥݥ
  int count           : ϥեޥơ֥ǿ

                : >0 ...  : =0 ... 
*/
int conv_huffman_code_to_tree( HuffmanCode* hc, HuffmanTree* ht, HuffmanTree* ht_end, int count )
{
  HuffmanTree* next = ht + 1; /* ɲäΥݥ */
  HuffmanTree* h;
  int i, l;

  ht->left = ht->right = NULL;

  for ( i = 0 ; i < count ; i++ ) {
    if ( ( hc[i] ).code == 0 && ( hc[i] ).length == 0 ) continue;
    h = ht;
    for ( l = ( hc[i] ).length - 1 ; l >= 0 ; l-- ) {
      if ( ( ( ( hc[i] ).code >> l ) & 1 ) != 0 ) {
	if ( h->right == NULL ) {
	  h->right = next;
	  next->left = next->right = NULL;
	  if ( ++next >= ht_end )
	    goto buffer_over_error;
	}
	h = h->right;
      } else {
	if ( h->left == NULL ) {
	  h->left = next;
	  next->left = next->right = NULL;
	  if ( ++next >= ht_end )
	    goto buffer_over_error;
	}
	h = h->left;
      }
    }
    h->code = i;
  }

  return( 1 );

 buffer_over_error:
  fprintf( stderr, "conv_huffman_code_to_tree : Buffer over\n" );
  return( 0 );
}

/*
  ǡ󤫤ǡФƥϥեޥڤ򤿤ɤꡢɤ֤

  unsigned char** encData    : ǡθ߰
  unsigned char* encData_end : ǡ
  HuffmanTree* ht            : ϥեޥڤκ
  char* p                    : ɤ߹߳ϥӥåȰ ( 0 - ( CHAR_BIT - 1 ) )

                       : >=0 ... ɤ ; <0 ... ǡã, ɤ߹ߤ˼Ԥ
*/
int get_from_huffman( unsigned char** encData, unsigned char* encData_end, HuffmanTree* ht, char* p )
{
  if ( *encData >= encData_end )
    goto buffer_over_error;

  while ( ht->left != NULL || ht->right != NULL ) {
    if ( ( ( **encData >> ( CHAR_BIT - *p - 1 ) ) & 1 ) != 0 ) {
      if ( ( ht = ht->right ) == NULL )
	goto fail_to_read_error;
    } else {
      if ( ( ht = ht->left ) == NULL )
	goto fail_to_read_error;
    }
    if ( ++( *p ) >= CHAR_BIT ) {
      if ( ++( *encData ) >= encData_end )
	goto buffer_over_error;
      *p = 0;
    }
  }
  return( ht->code );

 buffer_over_error:
  fprintf( stderr, "get_from_huffman : Buffer over\n" );
  return( -1 );

 fail_to_read_error:
  fprintf( stderr, "get_from_huffman : Fail to read code from huffamn tree\n" );
  return( -1 );
}

/*-----------------------------------------------------------------------------
  ǡ񤭹ߡɤ߹Ѵؿ
-----------------------------------------------------------------------------*/

/*
  ǡ˥ǡɲä

  unsigned char** encData    : ǡθ߰
  unsigned char* encData_end : ǡ
  char* p                    : 񤭹߳ϥӥåȰ ( 0 - ( CHAR_BIT - 1 ) )
  int code                   : ǡ
  unsigned int length        : ǡĹ ( 0 - MAX_LENGTH )

                       : >0 ... ｪλ ; =0 ... ǡã, length
*/
int compressData( unsigned char** encData, unsigned char* encData_end, char* p, int code, unsigned int length )
{
  unsigned char c;

  if ( length > MAX_LENGTH ) {
    fprintf( stderr, "compressData : Invalid parameter [length(=%d)]\n", length );
    return( 0 );
  }
  if ( *encData >= encData_end )
    goto buffer_over_error;
  code &= bitMask[length];

  /* ޤǽ񤭹ޤ줿 |*****...|........| */
  if ( *p != 0 ) {
    if ( length >= ( CHAR_BIT - *p ) ) {
      /* ǡޤǽ񤭹 |*****OOO|OOO.....| */
      c = code >> ( length - ( CHAR_BIT - *p ) );
      *( ( *encData )++ ) |= c;
      if ( *encData >= encData_end )
	goto buffer_over_error;
      length -= ( CHAR_BIT - *p );
      *p = 0;
    } else {
      /* ǡƽ񤭹 |***OOO..|........| */
      c = code << ( ( CHAR_BIT - *p ) - length );
      **encData |= c;
      *p += length;
      return( 1 );
    }
  }
  /* ХȤƬ񤭹 |********|........| */
  while ( length >= CHAR_BIT ) {
    c = code >> ( length - CHAR_BIT );
    *( ( *encData )++ ) = c;
    if ( *encData >= encData_end )
      goto buffer_over_error;
    length -= CHAR_BIT;
  }
  /* ĤΥӥå */
  if ( length > 0 )
    **encData = ( code << ( CHAR_BIT - length ) ) & 0xFF;
  *p = length;

  return( 1 );

 buffer_over_error:
  fprintf( stderr, "compressData : Buffer over\n" );
  return( 0 );
}

/*
  ǡ󤫤ǡФ

  unsigned char** encData    : ǡθ߰
  unsigned char* encData_end : ǡ
  char* p                    : ɤ߹߳ϥӥåȰ ( 0 - ( CHAR_BIT - 1 ) )
  int* code                  : ǡ
  unsigned int length        : ǡĹ ( 0 - MAX_LENGTH )

                       : >0 ... ｪλ ; =0 ... ǡã, length
*/
int decompressData( unsigned char** encData, unsigned char* encData_end, char* p, int* code, unsigned int length )
{
  if ( length > MAX_LENGTH ) {
    fprintf( stderr, "decompressData : Invalid parameter [length(=%d)]\n", length );
    return( 0 );
  }
  if ( *encData >= encData_end )
    goto buffer_over_error;
  *code = 0;

  /* ޤǽ񤭹ޤ줿 |*****...|........| */
  if ( *p != 0 ) {
    if ( length >= ( CHAR_BIT - *p ) ) {
      /* ǡޤɤ߹ |*****OOO|OOO.....| */
      *code = *( ( *encData )++ ) & bitMask[CHAR_BIT - *p];
      if ( *encData >= encData_end )
	goto buffer_over_error;
      length -= ( CHAR_BIT - *p );
      *p = 0;
    } else {
      /* ߤΥǡ󤫤ɤ߹ |***OOO..|........| */
      *code = ( **encData >> ( ( CHAR_BIT - *p ) - length ) ) & bitMask[length];
      *p += length;
      return( 1 );
    }
  }
  /* ХȤƬɤ߹ |********|........| */
  while ( length >= CHAR_BIT ) {
    *code <<= CHAR_BIT;
    *code |= *( ( *encData )++ );
    if ( *encData >= encData_end )
      goto buffer_over_error;
    length -= CHAR_BIT;
  }
  /* ĤΥӥå */
  if ( length > 0 ) {
    *code <<= length;
    *code |= **encData >> ( CHAR_BIT - length );
  }
  *p = length;

  return( 1 );

 buffer_over_error:
  fprintf( stderr, "decompressData : Buffer over\n" );
  return( 0 );
}

/*-----------------------------------------------------------------------------
  JPEG沽沽ؿ
-----------------------------------------------------------------------------*/

/*
  DCʬΥ󥳡

  Mcu* mcu                   : MCUǡ
  Mcu* mcu_end               : MCUǡ
  unsigned char* encData     : 沽ǡ
  unsigned char* encData_end : 沽ǡ
  int yuv                    : YUVʬΥǥå
  int hc_flag                : 0ʳǥϥեޥ󥳡ɤƺ

                       : 񤭹沽ǡμΥݥ (NULL:۾ｪλ)
*/
unsigned char* dc_encode( Mcu* mcu, Mcu* mcu_end, unsigned char* encData, unsigned char* encData_end, int yuv, int hc_flag )
{
  int prev_dc = 0;   /* DCʬ */
  char p = 0;        /* encDatabit */
  HuffmanCode* hc;

  set_bitMask();
  hc = ( yuv == Y_IDX ) ? dc_y : dc_uv;
  if ( hc_flag )
    if ( huffman_encode( mcu, mcu_end, hc, hc + SSSS_SIZE, count, count + SSSS_SIZE, dc_count ) == 0 )
      return( NULL );

  for ( ; mcu < mcu_end ; mcu++ ) {
    int diff = ( mcu->d )[0][0] - prev_dc; /* DCʬȤκ */
    unsigned int ssss = calcSSSS( diff );

    /* SSSS沽 */
    if ( ! compressData( &encData, encData_end, &p, ( hc[ssss] ).code, ( hc[ssss] ).length ) )
      return( NULL );
    if ( diff < 0 ) diff -= 1; /* ξ1 */

    /* ͤ沽 */
    if ( ! compressData( &encData, encData_end, &p, diff, ssss ) )
      return( NULL );
    prev_dc = ( mcu->d )[0][0];
  }

  return( encData + 1 );
}

/*
  ACʬΥ󥳡(ҤȤĤMCUʬ)

  Mcu* mcu                   : MCUǡ
  unsigned char* encData     : 沽ǡ
  unsigned char* encData_end : 沽ǡ
  HuffmanCode* hc            : ϥեޥ
  char* p                    : encDatabit

                       : 񤭹沽ǡμΥݥ (NULL:۾ｪλ)
*/
unsigned char* ac_mcu_encode( Mcu* mcu, unsigned char* encData, unsigned char* encData_end, HuffmanCode* hc, char* p )
{
  int run = 0;
  int zrl_count = 0;
  int sx = -1, sy = 1;
  int x = 1, y = 0;
  int i;

  do {
    int d = ( mcu->d )[x][y];
    if ( d == 0 ) {
      /* 0ʬλϡrun1 */
      if ( ++run >= RUN_SIZE ) {
	/* runRUN_SIZEۤZRL */
	++zrl_count;
	run -= RUN_SIZE;
      }
    } else {
      /* ZRL */
      for ( i = 0 ; i < zrl_count ; i++ )
	if ( ! compressData( &encData, encData_end, p, ( hc[ZRL] ).code, ( hc[ZRL] ).length ) )
	  return( NULL );
      unsigned int ssss = calcSSSS( d );
      HuffmanCode* h = &( hc[run * SSSS_SIZE + ssss] );
      if ( h->length == 0 ) {
	fprintf( stderr, "ac_mcu_encode : Zero length found ( run=%d : ssss=%d )\n", run, ssss );
	return( NULL );
      }

      /* runssssȹ礻沽 */
      if ( ! compressData( &encData, encData_end, p, h->code, h->length ) )
	return( NULL );
      if ( d < 0 ) d -= 1; /* ξ1 */

      /* ACʬ沽 */
      if ( ! compressData( &encData, encData_end, p, d, ssss ) )
	return( NULL );
      run = zrl_count = 0;
    }
  } while ( zigzag_run( &x, &y, &sx, &sy ) != 0 );

  /* 0ʬϢ³ޤ޺Ǹã硢EOB */
  if ( run != 0 || zrl_count != 0 )
    if ( ! compressData( &encData, encData_end, p, ( hc[EOB] ).code, ( hc[EOB] ).length ) )
      return( NULL );

  return( encData );
}

/*
  ACʬΥ󥳡

  Mcu* mcu                   : MCUǡ
  Mcu* mcu_end               : MCUǡ
  unsigned char* encData     : 沽ǡ
  unsigned char* encData_end : 沽ǡ
  int yuv                    : YUVʬΥǥå
  int hc_flag                : 0ʳǥϥեޥ󥳡ɤƺ

                       : 񤭹沽ǡμΥݥ (NULL:۾ｪλ)
*/
unsigned char* ac_encode( Mcu* mcu, Mcu* mcu_end, unsigned char* encData, unsigned char* encData_end, int yuv, int hc_flag )
{
  HuffmanCode* hc; 
  char p = 0;

  set_bitMask();
  hc = ( yuv == Y_IDX ) ? ac_y : ac_uv;
  if ( hc_flag )
    if ( huffman_encode( mcu, mcu_end, hc, hc + RUN_SIZE * SSSS_SIZE, count, count + RUN_SIZE * SSSS_SIZE, ac_count ) == 0 )
      return( NULL );

  for ( ; mcu < mcu_end ; mcu++ )
    if ( ( encData = ac_mcu_encode( mcu, encData, encData_end, hc, &p ) ) == NULL )
      return( NULL );

  return( encData + 1 );
}

/*
  DCʬΥǥ

  unsigned char* encData     : 沽ǡ
  unsigned char* encData_end : 沽ǡ
  Mcu* mcu                   : MCUǡ
  Mcu* mcu_end               : MCUǡ
  int yuv                    : YUVʬΥǥå

                       : ɤ߹沽ǡμΥݥ (NULL:۾ｪλ)
*/
unsigned char* dc_decode( unsigned char* encData, unsigned char* encData_end, Mcu* mcu, Mcu* mcu_end, int yuv )
{
  int prev_dc = 0; /* DCʬ */
  char p = 0;      /* encDatabit */
  HuffmanCode* hc; 
  int ssss;
  int diff;

  set_bitMask();
  hc = ( yuv == Y_IDX ) ? dc_y : dc_uv;
  if ( conv_huffman_code_to_tree( hc, huffmanTree, huffmanTree + HUFFMAN_MAX, SSSS_SIZE ) == 0 )
    return( NULL );
  for ( ; mcu < mcu_end ; mcu++ ) {
    if ( ( ssss = get_from_huffman( &encData, encData_end, huffmanTree, &p ) ) < 0 )
      return( NULL );
    if ( decompressData( &encData, encData_end, &p, &diff, ssss ) == 0 )
      return( NULL );
    /* Ǿ̥ӥåȤ0ξ硢οǤ뤳Ȥ򼨤 */
    if ( ( ssss > 0 ) && ( ( ( diff >> ( ssss - 1 ) ) & 1 ) == 0 ) ) {
      diff |= ( ~0 ) << ssss;
      diff += 1;
    }
    ( mcu->d )[0][0] = prev_dc + diff;
    prev_dc = ( mcu->d )[0][0];
  }

  return( encData + 1 );
}

/*
  ACʬΥǥ(ҤȤĤMCUʬ)

  unsigned char* encData     : 沽ǡ
  unsigned char* encData_end : 沽ǡ
  Mcu* mcu                   : MCUǡ
  char* p                    : encDatabit

                       : 񤭹沽ǡμΥݥ (NULL:۾ｪλ)
*/
unsigned char* ac_mcu_decode( unsigned char* encData, unsigned char* encData_end, Mcu* mcu, char* p )
{
  int i;
  int sx = -1, sy = 1;
  int x = 1, y = 0;
  int isEnd;

  do {
    if ( ( i = get_from_huffman( &encData, encData_end, huffmanTree, p ) ) < 0 )
      return( NULL );
    if ( i == EOB ) {
      do {
	( mcu->d )[x][y] = 0;
      } while ( zigzag_run( &x, &y, &sx, &sy ) != 0 );
      break;
    } else if ( i == ZRL ) {
      for ( i = 0 ; i < RUN_SIZE ; i++ ) {
	( mcu->d )[x][y] = 0;
	isEnd = zigzag_run( &x, &y, &sx, &sy );
      }
    } else {
      int run = i / SSSS_SIZE;
      unsigned int ssss = i % SSSS_SIZE;
      for ( i = 0 ; i < run ; i++ ) {
	( mcu->d )[x][y] = 0;
	zigzag_run( &x, &y, &sx, &sy );
      }
      if ( ! decompressData( &encData, encData_end, p, &i, ssss ) )
	return( NULL );
      /* Ǿ̥ӥåȤ0ξ硢οǤ뤳Ȥ򼨤 */
      if ( ( ssss > 0 ) && ( ( ( i >> ( ssss - 1 ) ) & 1 ) == 0 ) ) {
	i |= ( ~0 ) << ssss;
	i += 1;
      }
      ( mcu->d )[x][y] = i;
      isEnd = zigzag_run( &x, &y, &sx, &sy );
    }
  } while ( isEnd != 0 );

  return( encData );
}

/*
  ACʬΥǥ

  unsigned char* encData     : 沽ǡ
  unsigned char* encData_end : 沽ǡ
  Mcu* mcu                   : MCUǡ
  Mcu* mcu_end               : MCUǡ
  int yuv                    : YUVʬΥǥå

                       : ɤ߹沽ǡμΥݥ (NULL:۾ｪλ)
*/
unsigned char* ac_decode( unsigned char* encData, unsigned char* encData_end, Mcu* mcu, Mcu* mcu_end, int yuv )
{
  HuffmanCode* hc; 
  char p = 0;

  set_bitMask();
  hc = ( yuv == Y_IDX ) ? ac_y : ac_uv;
  if ( conv_huffman_code_to_tree( hc, huffmanTree, huffmanTree + HUFFMAN_MAX, RUN_SIZE * SSSS_SIZE ) == 0 )
    return( NULL );

  for ( ; mcu < mcu_end ; mcu++ )
    if ( ( encData = ac_mcu_decode( encData, encData_end, mcu, &p ) ) == NULL )
      return( NULL );

  return( encData + 1 );
}

/*
  ̻Ҳ롼

  Mcu* mcu     : MCUǡ
  Mcu* mcu_end : MCUǡ
  int quality  : ̻Ҳ٥ ( 0=̻ҲԤʤ ; 1() )
  int yuv      : YUVʬΥǥå
*/
void quantize( Mcu* mcu, Mcu* mcu_end, int quality, int yuv )
{
  int* qtable;
  int x, y;

  if ( quality == 0 ) return;
  qtable = ( yuv == Y_IDX ) ? &y_qtable[0][0] : &uv_qtable[0][0];
  for ( ; mcu < mcu_end ; mcu++ ) {
    for ( y = 0 ; y < MCU_SIZE ; y++ ) {
      for ( x = 0 ; x < MCU_SIZE ; x++ ) {
	( mcu->d )[x][y] /= qtable[ ( y * QTABLE_SIZE + x ) * QTABLE_SIZE / MCU_SIZE ] / quality;
      }
    }
  }
}

/*
  ̻Ҳ롼

  Mcu* mcu     : MCUǡ
  Mcu* mcu_end : MCUǡ
  int quality  : ̻Ҳ٥ ( 0=̻ҲԤʤ ; 1() )
  int yuv      : YUVʬΥǥå
*/
void deQuantize( Mcu* mcu, Mcu* mcu_end, int quality, int yuv )
{
  int* qtable;
  int x, y;

  if ( quality == 0 ) return;
  qtable = ( yuv == Y_IDX ) ? &y_qtable[0][0] : &uv_qtable[0][0];
  for ( ; mcu < mcu_end ; mcu++ ) {
    for ( y = 0 ; y < MCU_SIZE ; y++ ) {
      for ( x = 0 ; x < MCU_SIZE ; x++ ) {
	( mcu->d )[x][y] *= qtable[ ( y * QTABLE_SIZE + x ) * QTABLE_SIZE / MCU_SIZE ] / quality;
      }
    }
  }
}

