#include "jpeg.h"

/*
  ץѥ롼 **********************************************************
*/

/*
  ꤷץΥե饰å

   >=0 ... ץե饰
   < 0 ... ꤷץ󤬸Ĥʤ
*/
int check_option_flag( Option* option, const char* name ) {
  Option *p;

  for ( p = option ; p->option_tag != NULL ; p++ )
    if ( strcmp( p->option_name, name ) == 0 )
	return( p->flag );

  return( -1 );
}

/*
  ꤷץΥե饰å

   != 0 ... ͤ˼
    = 0 ... ꤷץ󤬸Ĥʤ, ͤ
*/
int get_option_value( Option* option, const char* name, int* value, int min_value, int max_value ) {
  Option *p;

  for ( p = option ; p->option_tag != NULL ; p++ ) {
    if ( strcmp( p->option_name, name ) == 0 ) {
      if ( p->flag >= min_value && p->flag <= max_value ) {
	*value = p->flag;
	return( 1 );
      } else {
	return( 0 );
      }
    }
  }

  return( 0 );
}

/*
  μ

  >1 ... ｪλ
  =0 ... ե̾ꤵƤʤ; ץλ˸ꤢ

  * ̵ʥץ̵뤵(顼ˤϤʤʤ)
*/
int getarg( int argc, char* argv[], Option* option, char** filename )
{
  int i, len;
  Option *p;

  *filename = NULL;

  for ( i = 1 ; i < argc ; i++ ) {
    if ( argv[i][0] == '-' ) {
      for ( p = option ; p->option_tag != NULL ; p++ ) {
	len = strlen( p->option_tag );
	if ( strncmp( p->option_tag, &argv[i][1], len ) == 0 ) {
	  if ( p->type ==VALUE ) {
	    if ( argv[i][len+1] == '\0' ) return( 0 );
	    p->flag = argv[i][len+1] - '0';
	  } else {
	    p->flag = 1;
	  }
	  break;
	}
      }
    } else
      if ( *filename == NULL ) *filename = argv[i];
  }

  return( ( *filename == NULL ) ? 0 : 1 );
}

/*
  إפɽ
*/
int help( DrawingArea *dest, DrawingArea *src, int param, int flag )
{
  Option *p;

  printf( "Usage : huffman -[options] filename\n\n" );

  for ( p = option ; p->option_tag != NULL ; p++ )
    if ( p->help != NULL )
      printf( "%s\n", p->help );

  return( -1 );
}

/*
  ǥХåѥ롼 **********************************************************
*/

/*
  YUVʬMCUʬƤɽ
*/
void print_mcu( double* yuv, Mcu* mcu, Coord* g_size )
{
  int x, y;

  for ( y = 0 ; y < MCU_SIZE ; y++ ) {
    for ( x = 0 ; x < MCU_SIZE ; x++ )
      printf( "%d, ", (int)yuv[y*g_size->x + x] );
    printf( "\n" );
  }
  printf( "\n" );

  for ( y = 0 ; y < MCU_SIZE ; y++ ) {
    for ( x = 0 ; x < MCU_SIZE ; x++ )
      printf( "%d, ", ( mcu->d )[x][y] );
    printf( "\n" );
  }
  printf( "\n" );
}

void delete_yuvarg( YUVArg* yuvarg )
{
  int i;

  for ( i = 0 ; i < YUV_SIZE ; i++ )
    if ( ( yuvarg->yuv )[i] != NULL ) free( yuvarg->yuv[i] );
  if ( yuvarg->mcu != NULL ) free( yuvarg->mcu );
  if ( yuvarg->encData != NULL ) free( yuvarg->encData );
}

int init_yuvarg( YUVArg* yuvarg )
{
  int i;
  Coord mcu_size;

  mcu_size.x = ( dest.width % MCU_SIZE == 0 ) ? dest.width / MCU_SIZE : dest.width / MCU_SIZE + 1;
  mcu_size.y = ( dest.height % MCU_SIZE == 0 ) ? dest.height / MCU_SIZE : dest.height / MCU_SIZE + 1;

  for ( i = 0 ; i < YUV_SIZE ; i++ )
    ( yuvarg->yuv )[i] = NULL;
  yuvarg->mcu = NULL;
  yuvarg->encData = NULL;

  for ( i = 0 ; i < YUV_SIZE ; i++ )
    if ( ( ( yuvarg->yuv )[i] = (double *) malloc( dest.width * dest.height * sizeof( double ) ) ) == NULL )
      goto error_exit;
  if ( ( yuvarg->mcu = (Mcu *) malloc( mcu_size.x * mcu_size.y * sizeof( Mcu ) ) ) == NULL )
    goto error_exit;
  if ( ( yuvarg->encData = (unsigned char *) malloc( dest.width * dest.height * sizeof( char ) * 4 ) ) == NULL )
    goto error_exit;

  return( 1 );

 error_exit:
  delete_yuvarg( yuvarg );

  return( 0 );
}

int jpeg_main( YUVArg* yuvarg, int yuv, Coord* g_size, int sample, int quality, int hc_flag )
{
  Mcu* mcu_end;  /* MCUǡ + 1 */
  unsigned char* enc_end; /* 󥳡ɥǡ + 1 */
  unsigned char* enc_max; /* 󥳡ǡѥХåեκ + 1 */
  unsigned int size; /* ̥ǡΥ */

  enc_max = yuvarg->encData + dest.width * dest.height * sizeof( char ) * 4;

  printf( "%s : sample=%d:%d , quality=%d\n", title[yuv], ( skip[sample][yuv] ).x, ( skip[sample][yuv] ).y, quality );

  /* 󥳡ɳ */
  mcu_end = mcu_encode( ( yuvarg->yuv )[yuv], yuvarg->mcu, g_size, &( skip[sample][yuv] ) ); /* DCTѴ */
  quantize( yuvarg->mcu, mcu_end, quality, yuv ); /* ̻Ҳ */
  if ( ( enc_end = dc_encode( yuvarg->mcu, mcu_end, yuvarg->encData, enc_max, yuv, hc_flag ) ) == NULL ) /* DCʬ沽 */
    return( 0 );
  if ( ( enc_end = ac_encode( yuvarg->mcu, mcu_end, enc_end, enc_max, yuv, hc_flag ) ) == NULL ) /* ACʬ沽 */
    return( 0 );

  size = enc_end - yuvarg->encData;
  printf( "encode size = %d\n", size );

  /* ǥɳ */
  if ( ( enc_end = dc_decode( yuvarg->encData, enc_max, yuvarg->mcu, mcu_end, yuv ) ) == NULL ) /* DCʬ沽 */
    return( 0 );
  if ( ac_decode( enc_end, enc_max, yuvarg->mcu, mcu_end, yuv ) == NULL )  /* ACʬ沽 */
    return( 0 );
  deQuantize( yuvarg->mcu, mcu_end, quality, yuv ); /* ̻Ҳ */
  mcu_decode( yuvarg->mcu, ( yuvarg->yuv )[yuv], g_size, &( skip[sample][yuv] ) ); /* IDCTѴ */

  /* DCTѴMCU(ǽΥ֥åΤ)ͤɽ */
  if ( check_option_flag( option, "print" ) != 0 )
    print_mcu( ( yuvarg->yuv )[yuv], yuvarg->mcu, g_size );

  /* DCTѴMCUɽ */
  if ( check_option_flag( option, "mcu" ) != 0 ) {
    copy_pixbuf_info( &dest, &( dct_img[yuv] ) );
    show_image( NULL, &( dct_img[yuv] ), title[yuv] );
    showMCU( &( dct_img[yuv] ), yuvarg->mcu, &( skip[sample][yuv] ) );
  }

  return( size );
}

/*
  ᥤ롼 **********************************************************
*/
int main( int argc, char *argv[] )
{
  char *filename;
  YUVArg yuvarg;
  Coord g_size;
  int sample, quality, hc_flag;
  int i;
  unsigned int size = 0;
  struct timeval s_time, e_time;

  if ( ! getarg( argc, argv, option, &filename ) ) {
    help( NULL, NULL, 0, 0 );
    return( -1 );
  }
  if ( ! get_option_value( option, "sample", &sample, 0, 2 ) ) return( -1 );
  if ( ! get_option_value( option, "quality", &quality, 0, 9 ) ) return( -1 );
  if ( ! get_option_value( option, "huffman", &hc_flag, 0, 1 ) ) return( -1 );

  get_option_value( option, "y_samplex", &( ( skip[sample][Y_IDX] ).x ), 1, 9 );
  get_option_value( option, "y_sampley", &( ( skip[sample][Y_IDX] ).y ), 1, 9 );

  get_option_value( option, "u_samplex", &( ( skip[sample][U_IDX] ).x ), 1, 9 );
  get_option_value( option, "u_sampley", &( ( skip[sample][U_IDX] ).y ), 1, 9 );

  get_option_value( option, "v_samplex", &( ( skip[sample][V_IDX] ).x ), 1, 9 );
  get_option_value( option, "v_sampley", &( ( skip[sample][V_IDX] ).y ), 1, 9 );

  gtk_init( &argc, &argv );

  /* ɽ */
  if ( ! show_image( filename, &dest, "original image" ) ) return( -1 );
  g_print( "image size : %d * %d * %ld = %ld\n", dest.width, dest.height, sizeof( Palet ), dest.width * dest.height * sizeof( Palet ) );

  if ( ! init_yuvarg( &yuvarg ) ) return( -1 );

  g_size.x = dest.width;
  g_size.y = dest.height;

  rgb2yuv( &dest, yuvarg.yuv ); /* RGBYUVѴ */
  calcCoeff();

  gettimeofday( &s_time, NULL );
  for ( i = 0 ; i < YUV_SIZE ; i++ ) {
    int j = jpeg_main( &yuvarg, i, &g_size, sample, quality, hc_flag );
    if ( j == 0 ) {
      delete_yuvarg( &yuvarg );
      return( -1 );
    }
    size += j;
  }
  gettimeofday( &e_time, NULL );

  e_time.tv_sec -= s_time.tv_sec;
  e_time.tv_usec -= s_time.tv_usec;
  if ( e_time.tv_usec < 0 ) {
    --e_time.tv_sec;
    e_time.tv_usec += 1000000;
  }

  printf( "Time  : %d.%06d sec.\n", (int)e_time.tv_sec, (int)e_time.tv_usec );
  printf( "Ratio : %d / %ld = %.2f%%.\n", size, dest.width * dest.height * sizeof( Palet ),
	  (double)size / (double)( dest.width * dest.height * sizeof( Palet ) ) * 100.0 );

  /* βɽ */
  copy_pixbuf_info( &dest, &src );
  show_image( NULL, &src, "test image" );
  yuv2rgb( &src, yuvarg.yuv ); /* YUVRGBѴ */

  gtk_main();

  delete_yuvarg( &yuvarg );

  return( 0 );
}
